<?php

//YOUR license number for cookies
define('VB_LICENSE', 'VBF6FC6A2E');

//drupalvb_msg defines
define('DVBERROR', 'error', true);
define('DVBLOGIN', 'login', true);
define('DVBLOGOUT', 'logout', true);
define('DVBREGISTER', 'register', true);

//version defines...
define('DVB_DRUPAL_VER', '4.7', true);
define('DVB_VER', '1.1', true);

//Function to connect to the vB database
function drupalvb_connect_db() {
  $vblink = mysql_connect(VB_SERVER, VB_USER, VB_PASS);
  if (!$vblink) die('Could not connect: ' . mysql_error());

  $vb_db_select = mysql_select_db(VB_DATABASE, $vblink);
  if (!$vb_db_select) die("Cannot select database . " . VB_DATABASE . ": " . mysql_error());

  return $vblink;  
}

//Function to initialize a vbulletin object
function _drupalvb_vb_init($class = false, $config = true, $options = true) {
  if ($class)
    $vbulletin = new vB_Registry();

  if ($config)
    $vbulletin->config = _drupalvb_fetch_config();

  if ($options)
    $vbulletin->options = _drupalvb_get_options();

  return $vbulletin;
}

//Function to close the link to the vB database
function drupalvb_close($vblink) {
  mysql_close($vblink);
}

//Function to grab the configuration/options of the vB installation
function _drupalvb_fetch_config() {
  $config = array();
  
  require_once('config.php');
  
  return $config;
}

//Function to parse (if necessary) and display appropriate drupalvb messages
function drupalvb_msg($msg, $arg = "unknown") {
  switch ($msg) {
    case DVBERROR:
      drupal_set_message("Error: " . $arg);
      break;
    case DVBLOGIN:
      drupal_set_message("Logging into the website gives you access to " . l(variable_get('drupalvb_forum_name', ''), variable_get('drupalvb_forum_address', ''), array('target' => '_blank')) . " as well.");
      break;
    case DVBREGISTER:
      drupal_set_message("You are now registered to access the site and the forums!");
      break;
    case DVBUPDATE:
      drupal_set_message("User information updated on the site and the forums.");
      break;
    default:
      drupal_set_message($arg);
  }  
  
  return;
}

//Function to set the necessary cookies for the user to be logged into the forum
function _drupalvb_set_login_cookies($userid, $password) {  
  $vbulletin = _drupalvb_vb_init();

  $cookie_prefix = (empty($vbulletin->config['Misc']['cookieprefix']) ? 'bb' : 
                     $vbulletin->config['Misc']['cookieprefix']);
  $cookie_path = $vbulletin->options['cookiepath'];
  $cookie_domain = $vbulletin->options['cookiedomain'];
  
  $expire = time() + 60 * 60 * 24 * 365;
  setcookie($cookie_prefix . 'sessionhash', md5("drupalvb" . $userid), $expire, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix . 'lastvisit', time(), $expire, $cookie_path, $cookie_domain); 
  setcookie($cookie_prefix . 'lastactivity', '0', $expire, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix . 'userid', $userid, $expire, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix . 'password', md5($password . VB_LICENSE), $expire, $cookie_path, $cookie_domain);
  
  return;
}

//Function to clear any database cookies.
function _drupalvb_clear_cookies() {  
  $vbulletin = _drupalvb_vb_init();

  $cookie_prefix = (empty($vbulletin->config['Misc']['cookieprefix']) ? 'bb' : 
                     $vbulletin->config['Misc']['cookieprefix']);
  $cookie_path = $vbulletin->options['cookiepath'];
  $cookie_domain = $vbulletin->options['cookiedomain'];

  //Clear our login cookies beginning 
  setcookie($cookie_prefix . 'sessionhash', '', 1, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix . 'lastvisit', '', 1, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix . 'lastactivity', '', 1, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix . 'userid', '', 1, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix . 'password', '', 1, $cookie_path, $cookie_domain);
  
  return;
}

function drupalvb_set_login_cookies() { }
function drupalvb_clear_cookies() { }

//Function to create an entry in the vB database user table
function _drupalvb_create_vb_user($username, $password, $email){

  //Double check to make sure we're not duplicating an entry...
  $result = db_query("SELECT userid FROM user WHERE username = '$username'");
  
  if (db_fetch_array($result)) {
    //The user existed somehow, so send the error and kick it out with a fail
    drupalvb_msg(DVBERROR, "Your username already existed on the forums. The duplication problem has been logged. " .
                           "If this error message continues to display, please contact the site administrator.");
    watchdog ("drupalvb", "Attempted to create a duplicate vB user.", WATCHDOG_ERROR);                           
    return false;
  }
  
  //Set up the necessary variables
  $salt = '';
  for ($i = 0; $i < 3; $i++) 
    $salt .= chr(rand(32, 126));
  $passhash = md5($password . $salt);
  $passdate = date('Y-m-d H:i:s', time());
  $joindate = time();

  //Attempt to grab the user title from the database  
  $result = db_query("SELECT title FROM usertitle WHERE minposts = 0");
  
  if ($resarray = db_fetch_array($result))
    $usertitle = $resarray['title'];
  else
    $usertitle = "Junior Member";

  //Grab the default timezone offset, divided by 3600 b/c the system.module timezone form is in seconds    
  $timezone = variable_get('drupalvb_default_timezone', '-18000');
  $timezone = intval($timezone) / 3600;

  /* Default new user options: I got these by setting up a new user how I wanted and looking in the
                               database to see what options were set for him. */
  $options = variable_get('drupalvb_default_options', '3415');
  
  //Default usergroup id
  $usergroupid = variable_get('drupalvb_default_usergroup', '2');
  
  //Set up the insertion query
  $query = "INSERT INTO user (username, usergroupid, password, passworddate, "
                           . "usertitle, email, salt, showvbcode, languageid, timezoneoffset, posts, "
                           . "joindate, lastvisit, lastactivity, options) "
         . "VALUES ('$username', '$usergroupid', '$passhash', '$passdate', "
                 . "'$usertitle', '$email', '$salt', '1', '1', '$timezone', '0', "
                 . "'$joindate', '$joindate', '$joindate', '$options');";
  $result = db_query($query);

 $userid = mysql_insert_id();

  db_query("INSERT INTO userfield VALUES (" . $userid . ", NULL, '', '', '', '')");
  db_query("INSERT INTO usertextfield VALUES (" . $userid . ", NULL, NULL, NULL, NULL, '', NULL, NULL)");
  
  //Return true if the vB user was created successfully
  return true;
}

//Function to update an entry in the vB database user table
function _drupalvb_update_vb_user($username, $password, $email, $salt){
  //Set up the necessary variables
  $setpass = '';
  if($password != ''){
    $passhash = md5($password . $salt);
    $passdate = date('Y-m-d H:i:s', time());
    $setpass = "password='$passhash', passworddate='$passdate', salt='$salt', ";
  }
  $lastdate = time();
  
  //Set up the insertion query
  db_query("UPDATE user SET " . $setpass . "email='$email', lastactivity='$lastdate' "
         . "WHERE username='$username'");

  return;
}

//Function to count the number of users online, guests and members.
function _drupalvb_get_users() {
  $vbulletin = _drupalvb_vb_init();
  
  $datecut = time() - $vbulletin->options['cookietimeout'];
  $numbervisible = 0;
  $numberregistered = 0;
  $numberguest = 0;

  if (!db_set_active('vbulletin'))
    drupal_set_message('Refer to README.txt for database setup instructions.');

  $result = db_query("SELECT user.username, user.usergroupid, session.userid, "
                   . "session.lastactivity FROM session AS session LEFT JOIN "
                   . "user AS user ON (user.userid = session.userid) "
                   . "WHERE session.lastactivity > %d", $datecut);

  $userinfos = array();

  while ($loggedin = db_fetch_array($result)) {
    $userid = $loggedin['userid'];
    if (!$userid)
      $numberguest++;
    elseif (empty($userinfos["$userid"])
        || ($userinfos["$userid"]['lastactivity'] < $loggedin['lastactivity']))
      $userinfos["$userid"] = $loggedin;
  }

  foreach ($userinfos as $userid => $loggedin)
    $numberregistered++;

  unset($userinfos);

  db_set_active('default');

  return array('guests' => $numberguest, 'members' => $numberregistered);
}

//Function to grab the number of new or recent posts for a user.
function _drupalvb_get_posts($scope = 'last') {
  global $user;
    
  //Queries the vB user database to find a matching set of user data
  if (!db_set_active('vbulletin'))
    drupal_set_message('Refer to README.txt for database setup instructions.');

  $result = db_query("SELECT userid, username, lastvisit FROM user "
                   . "WHERE username = '%s'", $user->name);

  //Make sure a user is logged in to get their last visit and appropriate post count.          
  if ($vb_user = db_fetch_array($result)) {
    if ($scope == 'last')
      $datecut = $vb_user['lastvisit'];
    elseif ($scope == 'daily')
      $datecut = time() - 86400;
      
    $result = db_query("SELECT postid FROM post WHERE dateline > %d", $datecut);
    $posts = db_num_rows($result);
  }
  else {
    $posts = 0;
  }

  db_set_active('default');

  return $posts;  
}

//Function to grab the usergroup names/ids from the database.
function _drupalvb_get_usergroups() {
  if (!db_set_active('vbulletin')) {
    drupal_set_message('Refer to README.txt for database setup instructions.');
    return array('Usergroups not found');
  }

  $result = db_query("SELECT usergroupid, title FROM usergroup");

  $usergroups = array();
  while ($data = db_fetch_object($result))
    $usergroups[$data->usergroupid] = $data->title;
  
  if (!$usergroups)
    $usergroups[] = 'Usergroups not found';
  
  db_set_active('default');
  
  return $usergroups;
}

// Function to get the vBulletin options.
function _drupalvb_get_options() {
  if (!db_set_active('vbulletin')) {
    drupal_set_message('Refer to README.txt for database setup instructions.');
    return null;
  }

  $result = db_query("SELECT data FROM datastore WHERE title = 'options'");

  if ($data = db_fetch_object($result))
    $options = unserialize($data->data);

  db_set_active('default');

  return $options;
}